//------------------------------------------------------------------------------
//
// Copyright (c) 2008 MStar Semiconductor, Inc.  All rights reserved.
//
//------------------------------------------------------------------------------
// FILE
//      ms_otg.h
//
// DESCRIPTION
//
// HISTORY
//
//------------------------------------------------------------------------------
#ifndef _MS_UDC_H_
#define _MS_UDC_H_

/******************************************************************************
 * SW patch config
 ******************************************************************************/
//***** for Cedric C3 patch*****//
#if	defined(CONFIG_ARCH_CEDRIC)
#define NO_DOUBLE_BUFF_CONFIG_PATCH   /// EP3 FIFO RAM size has only 64 bytes; can't use ping-pong buffer   
#endif
#if	defined(CONFIG_ARCH_CEDRIC)
#define DELAY_RECV_PKT_PATCH	//need to wait a SOF time frame to let hw set packet number
#endif

/******************************************************************************
 * HW eco config
 ******************************************************************************/
#if defined(CONFIG_MSTAR_KAISER) || defined(CONFIG_MSTAR_KAISERS) 
#define AHB_WDATA_CHANGES_WITHOUT_HREADY_ECO	
#endif
#if defined(CONFIG_MSTAR_KAISER) || defined(CONFIG_MSTAR_KAISERS) 
#define SHORTPKT_STATUS_CLEAR_ECO
#endif
#if defined(CONFIG_MSTAR_KAISER) || defined(CONFIG_MSTAR_KAISERS) 
#define	MONKEY_TEST_ECO	//avoid device can not enter high speed mode
#endif
#if defined(CONFIG_MSTAR_KAISER) || defined(CONFIG_MSTAR_KAISERS) 
#define ENABLE_TX_RX_RESET_ECO
#endif

//---- UPLL setting, normally it should be done in sboot
#if defined(CONFIG_MSTAR_KAISERIN)
#define ENABLE_UPLL_SETTING
#endif

//---- change to 55 interface
#if !defined(CONFIG_MSTAR_AMBER3) && \
	!defined(CONFIG_MSTAR_AMETHYST)
	#define ENABLE_UTMI_55_INTERFACE
#endif

/******************************************************************************
 * HW config
 ******************************************************************************/
#if	defined(CONFIG_ARCH_CEDRIC) || \
	defined(CONFIG_MSTAR_KAISER) || \
	defined(CONFIG_MSTAR_KAISERS) 
#define MAX_USB_DMA_CHANNEL  1
#else
#endif

#define EP0_FIFO_SIZE 64
#ifdef CONFIG_USB_GADGET_DUALSPEED
#define EP_FIFO_SIZE 512 
#else
#define EP_FIFO_SIZE 64
#endif

static const char ep0name [] = "ep0";
static const char *const ep_name[] = {
    ep0name,                                /* everyone has ep0 */
#if defined(CONFIG_ARCH_CEDRIC)	|| \
	defined(CONFIG_MSTAR_KAISER) || \
	defined(CONFIG_MSTAR_KAISERS)	
    /* msb250x four bidirectional bulk endpoints */
    "ep1in-bulk", "ep2out-bulk", "ep3in-int",
#endif
};
#define MSB250X_ENDPOINTS ARRAY_SIZE(ep_name)


#ifdef CONFIG_USB_GADGET_DUALSPEED
#define MIN_DMA_TRANSFER_BYTES       256
#else
#define MIN_DMA_TRANSFER_BYTES       32 
#endif


//------RIU, UTMI, USBC and OTG base address -----------------------------
#if	defined(CONFIG_ARCH_CEDRIC)
#define RIU_BASE           0xfd200000
#define UTMI_BASE_ADDR     GET_UDC_REG_ADDR(RIU_BASE, 0x3A80) 
#define USBC_BASE_ADDR     GET_UDC_REG_ADDR(RIU_BASE, 0x0700)
#define OTG0_BASE_ADDR     GET_UDC_REG_ADDR(RIU_BASE, 0x51000)
#endif

#if defined(CONFIG_MSTAR_KAISER) || \
	defined(CONFIG_MSTAR_KAISERS) 	
/*---port2 support device---*/
#define RIU_BASE           0xfd200000
#define UTMI_BASE_ADDR     GET_UDC_REG_ADDR(RIU_BASE, 0x2A00)
#define USBC_BASE_ADDR     GET_UDC_REG_ADDR(RIU_BASE, 0x10200)
#define OTG0_BASE_ADDR     GET_UDC_REG_ADDR(RIU_BASE, 0x11700)
#define BC_BASE_ADDR	   GET_UDC_REG_ADDR(RIU_BASE, 0x22F80)
#endif

#endif  /* define _MS_UDC_H_ */
